#!/usr/bin/env python
import networkx as NX
import sys,re,os


in_file = sys.argv[1]
size_threshold = sys.argv[2]
out_file = sys.argv[3]
monitor_pid = sys.argv[4] 



input_file = open(in_file,'r')
output_file = open(out_file,'w')
text = input_file.read()

m = re.compile("[\d]*->[\d]*")
s = re.compile("(?<=,size=)[\d]*")
n = re.compile("[\d]+")

subgraph = text.split('\nbreak\n')
print len(subgraph)
list = []

print >> output_file, 'digraph {'
print >> output_file, 'ratio = 0.1'
print >> output_file, 'start = 5'
print >> output_file, 'nclimit = 10.0'

for j in range(len(subgraph)):
#	print >> output_file , 'label="step %d";' % (j)
	G = NX.XDiGraph()
	edge = m.findall(subgraph[j])
	size = s.findall(subgraph[j])
	for i in range(len(edge)):
		node = n.findall(edge[i])
		if int(size[i]) > int(size_threshold):
			if int(monitor_pid) == int(999):
				G.add_edge(node[0],node[1],size[i])
			elif monitor_pid in node:
				G.add_edge(node[0],node[1],size[i])

	edge_list = G.edges()
	node_list = G.nodes()
	
	for p in range(len(node_list)):
		print >> output_file, str(j) + '.' + node_list[p]
	for p in range(len(edge_list)):
		print >> output_file, \
			str(j) + '.' + edge_list[p][0],'->', \
			str(j) + '.' + edge_list[p][1],'[label="'+edge_list[p][2]+'"]'
print >> output_file, '}'
output_file.close()
commd = 'dot -Tps %s -o %s.eps' % (out_file, out_file)
os.system(commd) 
