#!/usr/bin/env python
import networkx as NX
import sys,re,os


in_file = sys.argv[1]
size_threshold = sys.argv[2]
out_file = sys.argv[3]
monitor_pid = sys.argv[4] 

input_file = open(in_file,'r')
output_file = open(out_file, 'w')
text = input_file.read()

m = re.compile("[\d]*->[\d]*")
s = re.compile("(?<=,size=)[\d]*")
n = re.compile("[\d]+")

subgraph = text.split('\nbreak\n')
print len(subgraph)
list = []

print >> output_file, 'digraph {'
#print >> output_file, 'start = 5'
print >> output_file, 'nclimit = 50.0'
#print >> output_file, 'center = true;'
#print >> output_file, 'rankdir = LR;'

G = []
a = 1
for prev in range(len(subgraph)):
	G.append(NX.XDiGraph())
	edge = m.findall(subgraph[prev])
	size = s.findall(subgraph[prev])
	for i in range(len(edge)):
		node = n.findall(edge[i])
		if int(size[i]) > int(size_threshold):
			if int(monitor_pid) == int(999):
				G[prev].add_edge( node[0],  node[1], size[i])
			elif monitor_pid in node:
				G[prev].add_edge( node[0],  node[1], size[i])

for prev in range(len(subgraph) - 1):
	next = prev + 1
	prev_edge_list = G[prev].edges()
	next_edge_list = G[next].edges()
#	node_list = G.nodes()
	
# Nodes
	print >> output_file, 'subgraph cluster' + str(prev) + '{'
	if a == 1 :
		print >> output_file, 'node [style = filled, color = white];'
		print >> output_file, 'style = filled;'
		print >> output_file, 'color = lightgrey;'
		a = 0
	else:
	        print >> output_file, 'node [style = filled];'
		print >> output_file, 'color = blue'
		a = 1
		
	for p in prev_edge_list:
		print >> output_file, str(next) + '.' + p[1]
	for n in next_edge_list:
		print >> output_file, str(next) + '.' + n[0]
	print >> output_file, '}'

	for p in prev_edge_list:
		print >> output_file, \
			str(prev) + '.' + p[0],'->', \
			str(next) + '.' + p[1],'[label="' + p[2]+'"]'
print >> output_file, '}'
output_file.close()
commd = 'dot -Tps %s -o %s.eps' % (out_file, out_file)
os.system(commd) 

